;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				Timer Control				|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|
;===============================================================|
;			I/O Address				|
;===============================================================|
Int_Base		equ	0b0h	;
Int_Enable		equ	0b2h	;
Int_Case		equ	0b4h	;
Int_Eoi			equ	0b6h	;
BankSram		equ	0c1h	;
TIMER_Status		equ	0a2h	;Timer Status
TIMER_MaxCountH		equ	0a4h	;Hblank Load Count
TIMER_MaxCountV		equ	0a6h	;Vblank Load Count
TIMER_CounterH		equ	0a8h	;Hblank Down Counter
TIMER_CounterV		equ	0aah	;Vblank Down Counter
;===============================================================|
;			INT Status bit flag			|
;===============================================================|
INT_HblankSet		equ	080h	;HblanklZbg@(or)
INT_HblankReset		equ	07fh	;HblanklZbg(and)
;===============================================================|
;			COMM Status bit flag			|
;===============================================================|
Timer_H_Enable		equ	001h	;Hblank Int. Enable	(or)
Timer_H_Disable		equ	0feh	;Hblank Int. Disable	(and)
Timer_H_auto		equ	002h	;Vblank auto preset mode(or)
Timer_H_shot		equ	0fdh	;Vblank 1 shot mode	(and)
Timer_V_Enable		equ	004h	;Vblank Int. Enable 	(or)
Timer_V_Disable		equ	0fbh	;Vblank Int. Disable	(and)
Timer_V_auto		equ	008h	;Vblank auto preset mode(or)
Timer_V_shot		equ	0f7h	;Vblank 1 shot mode	(and)
;===============================================================|
;			萔					|
;===============================================================|
Timer_Open		equ	0303h	;Hblank Enable / Auto mode
Timer_Close		equ	0100h	;Hblank Disable
;
;	Frection = 12000 / ( timebase ~ tempo / 60 )
;	Frection = 0AFC80h / (timebase ~ tempo )
;
Timer_Tempo120		equ	125	;timebase 48 / Tempo 120
;===============================================================|
;		n[hEFA荞݂̃x[XxNg̎擾	|
;===============================================================|
;								|
;								|
;	Ԃl							|
;		al	x[XxNg				|
;								|
;		I/OA荞݃xN^ǂ			|
;===============================================================|
		even			;AhXzu
IntVector_Get	proc near		;
		in	al,Int_Base	;ǂݍ
		ret			;
IntVector_Get	endp			;
;===============================================================|
;		^C}[̓Jn				|
;===============================================================|
;								|
;								|
;	Ԃl							|
;								|
;								|
;		devicȅݒ				|
;===============================================================|
	even				;AhXzu
T_open	proc near			;
	push	ax			;WX^ۑ

	mov	ax,Timer_Open		;Set
	call	T_Set_Status		;

	call	T_init			;荞ݎ̐ݒ

	in	al,Int_Enable		;
	or	al,Int_HblankSet	;
	out	Int_Enable,al		;

	pop	ax			;WX^A
	ret				;
T_open	endp				;
;===============================================================|
;		^C}[̓I				|
;===============================================================|
;								|
;								|
;	Ԃl							|
;								|
;								|
;		devicȅ					|
;===============================================================|
	even				;AhXzu
T_close	proc near			;
	push	ax			;WX^ۑ

	mov	ax,Timer_Close		;Reset
	call	T_Set_Status		;

	in	al,Int_Enable		;
	and	al,Int_HblankReset	;
	out	Int_Enable,al		;
	mov	al,Int_HblankReset	;
	out	Int_Eoi,al		;o

	pop	ax			;WX^A
	ret				;
T_close	endp				;
;===============================================================|
;		^C}[̏ݒ				|
;===============================================================|
;								|
;								|
;	Ԃl							|
;								|
;								|
;		^C}[Tempo120ɂB			|
;===============================================================|
	even				;AhXzu
T_init	proc near			;
	push	ax			;WX^ۑ

	mov	ax,Timer_Tempo120	;
	call	T_Set_Frection		;

	pop	ax			;WX^A
	ret				;
T_init	endp				;
;===============================================================|
;		^C}[[h̐ݒ				|
;===============================================================|
;								|
;		AL	Output mode				|
;		AH	Set bit					|
;	Ԃl							|
;								|
;								|
;		[h̐ݒ					|
;===============================================================|
	even				;AhXzu
T_Set_Status	proc near		;
	push	dx			;WX^ۑ
	mov	dx,TIMER_Status		;dxI/O Address
	call	SP_Set_with_mask	;
	pop	dx			;WX^A
	ret				;
T_Set_Status	endp			;
;===============================================================|
;		^C}[̐ݒ				|
;===============================================================|
;								|
;		AX	荞ݎ				|
;	Ԃl							|
;								|
;								|
;		[h̐ݒ					|
;===============================================================|
	even				;AhXzu
T_Set_Frection	proc near		;
	out	Timer_MaxCountH,ax	;o
	ret				;
T_Set_Frection	endp			;
