/****************************************************************/
/*																*/
/*				Wander Swan Total Sound Driver					*/
/*								define file						*/
/*										for C Language			*/
/*																*/
/*								Programmed by					*/
/*										A.Watanabe				*/
/*																*/
/****************************************************************/
/*
 *	IL\̂̒`ȊÓA'wtd_def.asm'Ɠ̒`ƂȂĂ܂B
 *	ڍׂ́ADeveloper's ManualQƂ̂ƁB
 */

#ifndef _IL_WTD_H_
#define _IL_WTD_H_

#include	<sys/types.h>
#include	<sys/indirect.h>
#include	<sys/process.h>

/********************************************/
/*											*/
/*				IL\̂̒`				*/
/*											*/
/********************************************/
/* \̒` */
typedef struct {
	IL		super;
	int			(far *Stay)();
	int			(far *StayOut)();
	void		(far *Init)();
	char		(far *MusicPlay)(char far *Music);
	void		(far *MusicStop)();
	char		(far *EffectPlay)(char far *Effect);
	void		(far *EffectStop)();
	char		(far *PcmPlay)(char far *Pcm);
	void		(far *PcmStop)();
	char		(far *PcmVoiceSet)(char no,char far *wave);
	char		(far *SoftEmbSet)(char no,char far *emb);
	void	far	*(far *ChangeFar)(void far *add);
	void		(far *SoundSetChannel)(int mode);
	int			(far *SoundGetChannel)();
	void		(far *SoundSetOutput)(int mode);
	int			(far *SoundGetOutput)();
	int			(far *SoundGetRandom)();
	void		(far *SetMusicVolume)(char volume);
	char		(far *GetMusicVoluem)();
	void		(far *SetEffectVolume)(char volume);
	char		(far *GetEffectVolume)();
	void		(far *SetPcmVolume)(char volume);
	char		(far *GetPcmVolume)();
	void		(far *SetFIFO)(int size,char far *FIFO);
} WtdIL;

/********************************************/
/*											*/
/*					萔					*/
/*											*/
/********************************************/
/*==========================================*/
/* n[hEFA荞						*/
/*==========================================*/
/*	#define	InterruptVectorBase_WW	INT_HARDHAEW_VECTOR_BASE	*/	/* WonderWitch		*/
/*	#define	InterruptVectorBase		InterruptVectorBase_WW		*/	/* 荞݃xN^	*/

/*==========================================*/
/* Wander Swan far address					*/
/*==========================================*/
#define	IRAM_Segment		0x00000000L			/* {RAM */
#define	SRAM_Segment		(BANK_SRAM_ADDRESS)
#define	FROM_Segment		(BANK_ROM0_ADDRESS)

/*==========================================*/
/* {RAM Work Address						*/
/*==========================================*/
/*	#define	CommEnpty_intvector	0x00a0	*/	/*  0x28 * 4  */
/*	#define	Hblank_interrupt	0x00bc	*/	/*  0x2F * 4  */

#define	IRAM_SoundVoiceTable_WW	0x0180						/* WonderWitchݒ	*/
#define	IRAM_SoundVoiceTable	(IRAM_SoundVoiceTable_WW)	/* Fe[u		*/


/*==========================================*/
/* [N̈AhX						*/
/*==========================================*/
#define	WTD_WorkAdd_User	0x0000	/* [Up[N */
#define	WTD_WorkAdd_Wave	0x0100	/* F */
#define	WTD_WorkAdd_Emb		0x0200	/* Gx[v */
#define	WTD_WorkAdd_System	0x0380	/* p[gʍ\ */

#define	WTD_WorkAdd_ECh0	0x0400	/* Effect ch0 */
#define	WTD_WorkAdd_ECh1	0x0480	/* Effect ch1 */
#define	WTD_WorkAdd_ECh2	0x0500	/* Effect ch2 */
#define	WTD_WorkAdd_PCM		0x0580	/* PCM Voice */

#define	WTD_WorkAdd_Ch0		0x0600	/* p[gʍ\ */
#define	WTD_WorkAdd_Ch1		0x0680	
#define	WTD_WorkAdd_Ch2		0x0700	
#define	WTD_WorkAdd_Ch3		0x0780	
#define	WTD_WorkAdd_Ch4		0x0800	/**/
#define	WTD_WorkAdd_Ch5		0x0880	
#define	WTD_WorkAdd_Ch6		0x0900	
#define	WTD_WorkAdd_Ch7		0x0980	
#define	WTD_WorkAdd_Ch8		0x0a00	
#define	WTD_WorkAdd_Ch9		0x0a80	
#define	WTD_WorkAdd_Ch10	0x0b00	
#define	WTD_WorkAdd_Ch11	0x0b80	
#define	WTD_WorkAdd_Ch12	0x0c00	
#define	WTD_WorkAdd_Ch13	0x0c80	
#define	WTD_WorkAdd_Ch14	0x0d00	
#define	WTD_WorkAdd_Ch15	0x0d80	
#define	WTD_WorkAdd_Ch16	0x0e00	
#define	WTD_WorkAdd_Ch17	0x0e80	
#define	WTD_WorkAdd_Ch18	0x0f00	
#define	WTD_WorkAdd_Ch19	0x0f80	

#define	WTD_WorkChSize		0x0080	/* p[gʍ\̂̃TCY */
#define	WTD_WorkSize		0x1000	/* [NŜ̃TCY */
#define	WTD_WorkSize_H		0x0800	/* [NŜ̃TCY */

#define	WTD_WorkAdd_End		WTD_WorkSize

/********************************************/
/*											*/
/*			p[gʃ[N\			*/
/*											*/
/********************************************/
/*==========================================*/
/* Micro Soft  RIFF and Wave data formats	*/
/*==========================================*/
/* \̒` RIFF Header */
typedef struct {
	char	Head[4];		/* 'RIFF' */
	long	Size;			/* File Size(S-8) */
	char	Type[4];		/* 'WAVE' */
	char	Data;			/* f[^ */
} Riff;

/* \̒`	RIFF struct */
typedef struct {
	char	Head[4];		/* wb_ */
	long	Size;			/* wb_̃f[^̃TCY */
	char	Data;			/* wb_̃f[^ */
} RiffHed;

/* \̒`	WAVE fmt */
typedef struct {
	char	Head[4];		/* 'fmt ' */
	long	Size;			/* 16	[byte] */
	int		Type;			/* 1	(wave) */
	int		Channel;		/* 1	(mono) */
	long	SamplingRate;	/* 11025	[Hz] */
	long	SamplingSec;	/* 11025	[Byte] */
	int		DataSize;		/* 1	[Byte] */
	int		ChannelSize;	/* 8	[bit] */
} WaveFmt;

/* \̒`	WAVE Data */
typedef struct {
	char	Head[4];		/* 'data' */
	long	Size;			/* Data Size */
	char	Data;			/* wave data */
} WaveData;

/*==========================================*/
/* p[gʃ[N\					*/
/*==========================================*/
/* \̒` */
typedef struct {
	int		FlagControl;			/* 00-01	tO */
	char	FlagTai;				/* 02		^CtO */
	char	FlagSharp;				/* 03		#tO */
	char	FlagFlat;				/* 04		btO */
	char	Channel;				/* 05		/ׯ */
	int		Address;				/* 06-07	ṯڽ */
	char	LoopCount[8];			/* 08-0F	[v/PCM Address */
	char	LoopCountPointer;		/* 10		L߲ */
	char	Program;				/* 11		F */
	char	SweepLevel;				/* 12		ߒl/ɲӰ */
	char	SweepTime;				/* 13		ߎ */
	int		Leng;					/* 14-15	 */
	int		LengCounter;			/* 16-17	JE^[ */
	int		LengDefault;			/* 18-19	̫Ẳ */
	int		KeyOffTime;				/* 1A-1B	ްѐl */
	int		KeyOnDelay;				/* 1C-1D	ިڲ */
	char	KeyShift;				/* 1E		ڒl */
	char	Key;					/* 1F		 */
	char	KeySet[8];				/* 20-27	o͂ */
	char	KeySetPointer;			/* 28		L߲ */
	char	AcsentVelocity;			/* 29		ANZgl */
	int		BendSet;				/* 2A-2B	o͂g */
	int		Bend;					/* 2C-2D	wg */
	int		BendDetune;				/* 2E-2F	fB`[ */
	char	BendLfoDecayRate;		/* 30		LFOfBPCCg */
	char	BendLfoSpeedRate;		/* 31		LFOXs[h */
	int		BendLfoLevel;			/* 32-33	LFOψ */
	char	BendLfoCount;			/* 34		LFOω */
	char	BendLfoRateCounter;		/* 35		LFOCgpJE^ */
	int		BendLfoLevelSet;		/* 36-37	LFO݂̕ψ */
	char	BendLfoCountCounter;	/* 38		LFO񐔗pJE^ */
	char	BendEmbAddress;			/* 39		EMBԍiڽj */
	char	BendEmbRate;			/* 3A		EMBCg */
	char	BendEmbCounter;			/* 3B		EMBJE^[ */
	char	BendEmbMaxMin;			/* 3C		EMBő^ŏl */
	char	BendEmbLevelSet;		/* 3D		EMBψ */
	char	ReleaseVolume;			/* 3E		KeyOff̉ */
	char	ExprPanSet;				/* 3F		o/ުۼè */
	char	ExprSet;				/* 40		o͉/گ */
	char	Expr;					/* 41		/گ */
	int		ExprDetune;				/* 42-43	ʑl */
	char	ExprLfoDecayRate;		/* 44		LFOfBPCCg */
	char	ExprLfoSpeedRate;		/* 45		LFOXs[h */
	int		ExprLfoLevel;			/* 46-47	LFOψ */
	char	ExprLfoCount;			/* 48		LFOω */
	char	ExprLfoRateCounter;		/* 49		LFOCgpJE^ */
	int		ExprLfoLevelSet;		/* 4A-4B	LFO݂̕ψ */
	char	ExprLfoCountCounter;	/* 4C		LFO񐔗pJE^ */
	char	ExprEmbAddress;			/* 4D		EMBԍiڽj */
	char	ExprEmbRate;			/* 4E		EMBCg */
	char	ExprEmbCounter;			/* 4F		EMBJE^[ */
	char	ExprEmbMaxMin;			/* 50		EMBő^ŏl */
	char	ExprEmbLevelSet;		/* 51		EMBψ */
	char	WorkAddress;			/* 52		[Nڽ8BIT */
	char	OctaveSet;				/* 53		o͂IN^[u */
	char	Octave;					/* 54		wIN^[u */
	char	GateTime8;				/* 55		ްсiQ,U) */
	int		GateTimeStepLast;		/* 56-57	ް(q) */
	int		GateTimeStepFirst;		/* 58-59	ް(u) */
	char	VolumeUpDown;			/* 5A		΃{[̑l */
	int		ModDecay;				/* 5B-5C	Ӽޭڰ ިڲ */
	char	ModLevel;				/* 5D		Ӽޭڰ  */
	char	ModLevelSet;			/* 5E		݂Ӽޭڰ  */
	char	Null_5F;				/* 5F		gp */
	char	PanSet;					/* 60		o̓p|bg */
	char	Pan;					/* 61		p|bg */
	int		PanDetune;				/* 62-63	ʑl */
	char	PanLfoDecayRate;		/* 64		LFOfBPCCg */
	char	PanLfoSpeedRate;		/* 65		LFOXs[h */
	int		PanLfoLevel;			/* 66-67	LFOψ */
	char	PanLfoCount;			/* 68		LFOω */
	char	PanLfoRateCounter;		/* 69		LFOCgpJE^ */
	int		PanLfoLevelSet;			/* 6A-6B	LFO݂̕ψ */
	char	PanLfoCountCounter;		/* 6C		LFO񐔗pJE^ */
	char	PanEmbAddress;			/* 6D		EMBԍiڽj */
	char	PanEmbRate;				/* 6E		EMBCg */
	char	PanEmbCounter;			/* 6F		EMBJE^[ */
	char	PanEmbMaxMin;			/* 60		EMBő^ŏl */
	char	PanEmbLevelSet;			/* 61		EMBψ */
	int		ProgramRate;			/* 62-63	FςB */
	char	Program1st;				/* 64		F̏l */
	char	Program2nd;				/* 65		oω */
	char	Program3rd;				/* 66		KeyOff㉹F */
	char	ProgramDecay;			/* 67		oω2 */
	int		ProgramDecayRate;		/* 68-69	oω2 */
} Wtd;

/* \̈ʒu */
#define	WTD_BendLFO		Wtd.BendLfoDecayRate
#define	WTD_ExprLFO		Wtd.ExprLfoDecayRate
#define	WTD_PanLFO		Wtd.PanLfoDecayRate
#define	WTD_BendEmb		Wtd.BendEmbAddress
#define	WTD_ExprEmb		Wtd.ExprEmbAddress
#define	WTD_PanEmb		Wtd.PanEmbAddress

/* ChLFO\ */
typedef struct{
	char	DecayRate;		/* LFOfBPCCg */
	char	SpeedRate;		/* LFOXs[h */
	int		Level;			/* LFOψ */
	char	Count;			/* LFOω */
	char	RateCounter;	/* LFOCgpJE^ */
	int		LevelSet;		/* LFO݂̕ψ */
	char	CountCounter;	/* LFO񐔗pJE^ */
} WTD_ChLfo;

/* ChEmb\ */
typedef struct{
	char	Address;		/* EMBԍiڽj */
	char	Rate;			/* EMBCg */
	char	Counter;		/* EMBJE^[ */
	char	MaxMin;			/* EMBő^ŏl */
	char	LevelSet;		/* EMBψ */
} WTD_ChEmb;

/* Flag bit */
/* Set */
#define	WTD_Ctrl_BendLfo		00001h	/* kenXCb` */
#define	WTD_Ctrl_BendEmb		00002h	/* Gx[vXCb` */
#define	WTD_Ctrl_ExprLfo		00004h	/* ʂkenXCb` */
#define	WTD_Ctrl_ExprEmb		00008h	/* ʃGx[vXCb` */
#define	WTD_Ctrl_PanLfo			00010h	/* pkenXCb` */
#define	WTD_Ctrl_PanEmb			00020h	/* pGx[vXCb` */
#define	WTD_Ctrl_Acsent			00040h	/* ̉K̓ANZg */
#define	WTD_Ctrl_EmbFreq		00080h	/* Gx[v bit */
#define	WTD_Ctrl_EmbVol			00100h	/* ʃGx[v bit */
#define	WTD_Ctrl_EmbPan			00200h	/* pGx[v bit */
#define	WTD_Ctrl_Vol0			00400h	/* ʁO */
#define	WTD_Ctrl_WorkSw			00800h	/* ̃R}h́A[NQ */
#define	WTD_Ctrl_WorkCy			01000h	/* [NZʁAI[o[t[ */
#define	WTD_Ctrl_WorkZe			02000h	/* [NZʁAOɂȂB */
#define	WTD_Ctrl_Effect			04000h	/* ̃p[g͌ʉH */
#define	WTD_Ctrl_PlayEnd		08000h	/* tI */
/* Reset */
#define	WTD_Ctrl_BendLfoR		0fffeh	/*	;kenXCb` */
#define	WTD_Ctrl_BendEmbR		0fffdh	/*	;Gx[vXCb` */
#define	WTD_Ctrl_ExprLfoR		0fffbh	/*	;ʂkenXCb` */
#define	WTD_Ctrl_ExprEmbR		0fff7h	/*	;ʃGx[vXCb` */
#define	WTD_Ctrl_PanLfoR		0ffefh	/*	;pkenXCb` */
#define	WTD_Ctrl_PamEmbR		0ffdfh	/*	;pGx[vXCb` */
#define	WTD_Ctrl_AcsentR		0ffbfh	/*	;̉K̓ANZg */
#define	WTD_Ctrl_EmbFreqR		0ff7fh	/*	;Gx[v bit */
#define	WTD_Ctrl_EmbVolR		0feffh	/*	;ʃGx[v bit */
#define	WTD_Ctrl_EmbPanR		0fdffh	/*	;pGx[v bit */
#define	WTD_Ctrl_Vol0R			0fbffh	/*	;ʁO */
#define	WTD_Ctrl_WorkSwR		0f7ffh	/*	;̃R}h́A[NQ */
#define	WTD_Ctrl_WorkCyR		0efffh	/*	;[NZʁAI[o[t[ */
#define	WTD_Ctrl_WorkZeR		0dfffh	/*	;[NZʁAOɂȂB */
#define	WTD_Ctrl_EffectR		0bfffh	/*	;̃p[g͌ʉH */
#define	WTD_Ctrl_PlayEndR		07fffh	/*	;tI */

/*==========================================*/
/* p[gʃ[N\					*/
/*==========================================*/
/* \̒` */
typedef struct {
	int		Flag;				/* 00	Flag */
	int		ProgramOffset;		/* 02	Program Offset Address */
	int		ProgramSegment;		/* 04	Program Segment Address */
	int		MusicOffset;		/* 06	Music Offset Address*/
	int		MusicSegment;		/* 08	Music Segment Address */
	int		EffectOffset;		/* 0A	Effect Offset Address */
	int		EffectSegment;		/* 0C	Effect Segment Address */
	int		PcmOffset;			/* 0E	Pcm Offset Address */
	int		PcmSegment;			/* 10	Pcm Segment Address */
	int		StayOutMask;		/* 12	풓֎~ */
	int		OldIntvector[2];	/* 14	O̊荞݃xN^ */
	int		OldIntvectorCom[2];	/* 18	O̊荞݃xN^ */
	int		ComFIFO_Offset;		/* 1C	FIFO Offset Address */
	int		ComFIFO_Segment;	/* 1E	FIFO Segment Address */
	char	WTD_Sys_PCMVoice;	/* 20	n[hEFA PCM Voice */
	char	VolumeMusic;		/* 21	\tgEFA t */
	char	VolumeEffect;		/* 22	\tgEFA ʉ */
	char	VolumePCM;			/* 23	\tgEFA PCM */
	int		Tempo;				/* 24	e| */
	int		TempoCounter;		/* 26	e|JE^ */
	char	MusicPart;			/* 28	t̃p[g(ő20) */
	char	EffectPart;			/* 29	ʉ̃p[g(ő3) */
	int		ComFIFO_Cnt;		/* 2A	FIFO Counter */
	int		ComFIFO_Adr;		/* 2C	FIFO Address */
	int		ComFIFO_Size;		/* 2E	FIFO Size */
	char	RunningStatus;		/* 30	MIDI Running Status */
	char	InterruptBase;		/* 31	荞݃x[XxN^ */
	int		VoiceTableOffset;	/* 32	Fe[u(IRAM)AhX */
} Wtd_Sys;

/* Flag bit */
/* Set */
#define	WTD_Sys_Music			0x0001	/* t */
#define	WTD_Sys_Effect			0x0002	/* ʉ */
#define	WTD_Sys_Pcm				0x0004	/* PCM{CX */
#define	WTD_Sys_3				0x0008	/* NULL	(FPCM VoiceI) */
#define	WTD_Sys_Midi			0x0010	/* MIDI[h(VXeł͖gp) */
#define	WTD_Sys_5				0x0020	/* NULL */
#define	WTD_Sys_6				0x0040	/* NULL */
#define	WTD_Sys_TimerEmulate	0x0080	/* ^C}[G~[g */
#define	WTD_Sys_ChannelMode1	0x0100	/* `l[h ch1 */
#define	WTD_Sys_ChannelMode2	0x0200	/* `l[h ch2 */
#define	WTD_Sys_ChannelMode3	0x0400	/* `l[h ch3 */
#define	WTD_Sys_ChannelMode4	0x0800	/* `l[h ch4 */
#define	WTD_Sys_EffectMask1		0x1000	/* ʉp[g}XN ch1 */
#define	WTD_Sys_EffectMask2		0x2000	/* ʉp[g}XN ch2 */
#define	WTD_Sys_EffectMask3		0x4000	/* ʉp[g}XN ch3 */
#define	WTD_Sys_EffectMask4		0x8000	/* ʉp[g}XN ch4 */
/* Reset */
#define	WTD_Sys_MusicR			0xFFFE	/* t */
#define	WTD_Sys_EffectR			0xFFFD	/* ʉ */
#define	WTD_Sys_PcmR			0xFFFB	/* PCM{CX */
#define	WTD_Sys_3R				0xFFF7	/* NULL	(FPCM VoiceI) */
#define	WTD_Sys_MidiR			0xFFEF	/* MIDI[h(VXeł͖gp) */
#define	WTD_Sys_5R				0xFFDF	/* NULL */
#define	WTD_Sys_6R				0xFFBF	/* NULL */
#define	WTD_Sys_TimerEmulateR	0xFF7F	/* ^C}[G~[g */
#define	WTD_Sys_ChannelMode1R	0xFEFF	/* `l[h ch1 */
#define	WTD_Sys_ChannelMode2R	0xFDFF	/* `l[h ch2 */
#define	WTD_Sys_ChannelMode3R	0xFBFF	/* `l[h ch3 */
#define	WTD_Sys_ChannelMode4R	0xF7FF	/* `l[h ch4 */
#define	WTD_Sys_EffectMask1R	0xEFFF	/* ʉp[g}XN ch1 */
#define	WTD_Sys_EffectMask2R	0xDFFF	/* ʉp[g}XN ch2 */
#define	WTD_Sys_EffectMask3R	0xBFFF	/* ʉp[g}XN ch3 */
#define	WTD_Sys_EffectMask4R	0x7FFF	/* ʉp[g}XN ch4 */

/*==========================================*/
/* \tgEFAGx[v\			*/
/*==========================================*/
/* \̒` */
typedef struct {
	char	AR;				/* Attack Rate */
	char	AS;				/* Attack Speed */
	char	AL;				/* Attack Level */
	char	FL;				/* First Level */
	char	DR;				/* Decay Rate */
	char	DS;				/* Decay Speed */
	char	DL;				/* Decay Level */
	char	Null1;			/* gp */
	char	SR;				/* Sustain Rate */
	char	SS;				/* Sustain Speed */
	char	SL;				/* Sustain Level */
	char	Null2;			/* gp */
	char	RR;				/* Relase Rate */
	char	RS;				/* Relase Speed */
	char	RL;				/* Relase Level */
	char	Null3;			/* gp */
} Wtd_Emb;

/*==========================================*/
/* ȃf[^\							*/
/*==========================================*/
/* wb_\ */
typedef struct{
	char	Name[4];		/* 00-03h	:Iʎq "'WTD',0" */
	char	VersionN;		/* 04h		:Version  */
	char	VersionS;		/* 05h		:Version  */
	int		Extr;			/* 06-07h	:gwb_TCY */
	char	Emb;			/* 08h		:Gx[v */
	char	Voice;			/* 09h		:g`f[^ */
	char	Part;			/* 0Ah		:p[g */
	char	TimeBase;		/* 0Bh		:S̕ */
	void	*ExtrAdr;		/* 0C-0Dh	:gwb_̃AhX */
	char	*DataAdr;		/* 0E-0Fh	:f[^̃AhX */
	void	*(*PartAdr);	/* 10-11h	:ȃf[^擪AhX̃AhX */
} WTD_Mus;

/* gwb_\ */
typedef struct{
	char	Null;			/* ̍\̂́Agp */
} WTD_MusEx;

/*==========================================*/

#endif _IL_WTD_H_
